#include "Board.h"
#include "porty.h"
#include "lcd.h"
void wyslij(char dane);
void setphs(unsigned int faza);
void amplituda(unsigned int amp);
void setfreq(unsigned long freq);
void setfreq2(unsigned long freq);
void init_dds(void);
void init_fsk_pin(unsigned long freq, unsigned long freq2);
void init_osk_pin(unsigned long freq, unsigned char rate);
void setdeltafreq(unsigned long freq);
void setramprate(unsigned long rrate);

extern float pot;
extern unsigned int gmode;
void init_osk_pin(unsigned long freq, unsigned char rate)
{
char temp[10];
AT91PS_PIO p_pPio = AT91C_BASE_PIOA;
wyslij(7);
wyslij(16);
wyslij(75);
wyslij(16);
wyslij(112);
setp2; //ioud
clrp2;
wyslij(10);
wyslij(rate);
setp2; //ioud
clrp2;
setfreq(freq);
lcdclr();
lcdtxt("Ramped OOK X2");
lcdxy(0,1);
sprntf(temp,"%i",freq);
lcdtxt("fn:");
lcdtxt(temp);
lcdtxt("Hz");

}

void init_fsk_pin(unsigned long freq, unsigned long freq2)
{
char temp[10];
AT91PS_PIO p_pPio = AT91C_BASE_PIOA;
wyslij(7);
wyslij(16);
wyslij(75);
wyslij(18);
wyslij(96);
setp2; //ioud
clrp2;
setfreq(freq);
setfreq2(freq2);
lcdclr();
lcdtxt("FSK-gniazdo X1");

}


void init_dds(void)
{
AT91PS_PIO p_pPio = AT91C_BASE_PIOA;
wyslij(7);
wyslij(16);
wyslij(75);
wyslij(16);
wyslij(96);
setp2; //ioud
clrp2;
}


void setphs(unsigned int faza)
{
AT91PS_PIO p_pPio = AT91C_BASE_PIOA; 
unsigned int fazatemp=0;
float fazaset=0;
fazaset=faza*45.51;
faza=(unsigned char)fazaset;
fazatemp=(unsigned int)fazaset>>8;
wyslij(0);
wyslij(fazatemp);
wyslij(faza);
setp2;  //IO update
clrp2;
}

void amplituda(unsigned int amp)
{
AT91PS_PIO p_pPio = AT91C_BASE_PIOA; 
unsigned char a,b;
a=amp>>8;
b=amp;
wyslij(8);
wyslij(a);
wyslij(b);
setp2;  //IO update
clrp2;

}

void wyslij(char dane)
{
AT91PS_PIO p_pPio = AT91C_BASE_PIOA; 
unsigned char bufor[8];
char y=0;


for (y=0;y<8;y++)
	{
	if ((dane % 2) == 1)
		bufor[7-y] = '1';
	else
		bufor[7-y] = '0';
		dane/=2;
	}

for (char x=0;x<8;x++)
	{
	if (bufor[x]=='1')
		{
		setp1;
		setp3;
		clrp3;
		clrp1;		
		}
	
	if (bufor[x]=='0')
		{
		setp3;
		clrp3;
		}
	}
}

void setdeltafreq(unsigned long freq)
{
AT91PS_PIO p_pPio = AT91C_BASE_PIOA; 
unsigned long f;
char a,b,c,d;


f=freq*pot;
d=f;
f=f>>8;
c=f;
f=f>>8;
b=f;
f=f>>8;
a=f;

wyslij(4);
wyslij(a);
wyslij(b);
wyslij(c);
wyslij(d);
wyslij(0);
wyslij(0);
setp2;  //IO update
clrp2;
}


void setramprate(unsigned long rrate)
{
AT91PS_PIO p_pPio = AT91C_BASE_PIOA; 
unsigned long f;
unsigned char a,b,c;
f=rrate;
c=f;
f=f>>8;
b=f;
f=f>>8;
a=f;

wyslij(6);
wyslij(a);
wyslij(b);
wyslij(c);
//wyslij(3);
//wyslij(255);
//wyslij(255);

setp2;  //IO update
clrp2;
}


void setfreq2(unsigned long freq)
{
AT91PS_PIO p_pPio = AT91C_BASE_PIOA; 
unsigned long f;
unsigned char a,b,c,d;
f=freq*pot;
d=f;
f=f>>8;
c=f;
f=f>>8;
b=f;
f=f>>8;
a=f;

wyslij(3);
wyslij(a);
wyslij(b);
wyslij(c);
wyslij(d);
wyslij(0);
wyslij(0);
setp2;  //IO update
clrp2;
}


void setfreq(unsigned long freq)
{
AT91PS_PIO p_pPio = AT91C_BASE_PIOA; 
unsigned long f;
unsigned char a,b,c,d;

f=freq*pot;
d=f;
f=f>>8;
c=f;
f=f>>8;
b=f;
f=f>>8;
a=f;

wyslij(2);
wyslij(a);
wyslij(b);
wyslij(c);
wyslij(d);
wyslij(0);
wyslij(0);
if ((gmode!=10)&&(gmode!=11)&&(gmode!=8)) {
setp2;  //IO update
clrp2;
}
}
