#include "Board.h"
#include "porty.h"
#include "lcd.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "rprintf.h"
#include "a2d.h"
#include "uartintr.h"
#include "dds.h"
void uart1przerwanie(void);
void modulacjafm(unsigned long nosna,unsigned long dewiacja,unsigned int speed);
void modulacjaam(unsigned long nosna,unsigned int depth, unsigned int speed);
void sweep(unsigned long freq1,unsigned long freq2,unsigned long step,unsigned int speed);
void AT91F_TC_Open ( AT91PS_TC TC_pt, unsigned int Mode, unsigned int TimerId);
void timer1_int(void);
void fsk(unsigned long freq1,unsigned long freq2,unsigned int speed);
void ask(unsigned long freq1,unsigned int amp1,unsigned int amp2, unsigned int speed);
void psk(unsigned long freq1,unsigned int phs1,unsigned int phs2,unsigned int speed);
void qpsk(unsigned long freq1, unsigned int speed);
void init_bpsk_pin(unsigned long freq1,unsigned int phs1,unsigned int phs2);
void init_rampfsk(unsigned long freq1,unsigned long freq2,unsigned long step,unsigned long speed);
void qam16(unsigned long freq1,unsigned int speed);
void qam8(unsigned long freq1,unsigned int speed);
void dbpsk(unsigned long freq1,unsigned int speed);
void fhssbpsk(unsigned long freq1,unsigned int tc,unsigned long step);
void fhssask(unsigned long freq1,unsigned int tc,unsigned long step);
void longdelay(void);
char temp[16];

long dev=0;
unsigned long gfreq,gfreq1,gfreq2,gstep,gspeed,gphs1,gphs2;
unsigned char gdane[50];
unsigned int gmode=0,gdepth,gamp,gamp1,gamp2,flaga=0;
unsigned int delay=20;
unsigned int gtc=0;
unsigned long out[147];    			//tablica danych z czestotliwosciami wyjsciowymi dla FM
unsigned int arb[1026];
static char czy=0;

float pot=13.7861;

double l=0,speedam=0,speedfm=0;
static unsigned int licznik=0;

unsigned int sinus[73]		//tabela wartoci funkcji sinus do modulacji programowych
 = {0,11,22,33,44,55,66,76,87,97,108,118,127,137,146,155,164,172,180,188,196,203,209,215,221,227,231,236,240,244,247,249,252,253,
255,255,255,255,255,253,252,249,247,244,240,236,232,227,221,215,209,203,196,188,181,173,164,155,146,
137,128,118,108,98,87,77,66,55,44,33,22,11};		

void longdelay(void)		//funkcja dugiego opnienia
{
for (unsigned char d=0;d<150;d++)
_delay(65000);

}

void fhssask(unsigned long freq1,unsigned int tc,unsigned long step)
{
l=0;
licznik=0;
delay=tc;			//ustawienie parametrw modulacji
gstep=step;
gfreq1=freq1;
setphs(0);
gmode=14;			
lcdclr();
lcdtxt("FHSS - BASK");
lcdxy(0,1);
sprntf(temp,"%i",freq1);
lcdtxt("fn:");
lcdtxt(temp);
lcdtxt("Hz");
AT91C_BASE_TC1->TC_CCR = AT91C_TC_CLKEN;			//wlaczenie sygnalu zegarowego
AT91C_BASE_TC1->TC_CCR = AT91C_TC_SWTRG ;
}

void fhssbpsk(unsigned long freq1,unsigned int tc,unsigned long step)
{
l=0;
licznik=0;
delay=tc;		//ustawienie parametrw modulacji
gstep=step;
gfreq1=freq1;
setphs(0);
gmode=13;
lcdclr();
lcdtxt("FHSS - BPSK");
lcdxy(0,1);
sprntf(temp,"%i",freq1);
lcdtxt("fn:");
lcdtxt(temp);
lcdtxt("Hz");
AT91C_BASE_TC1->TC_CCR = AT91C_TC_CLKEN;			//wlaczenie sygnalu zegarowego
AT91C_BASE_TC1->TC_CCR = AT91C_TC_SWTRG ;	
}
void dbpsk(unsigned long freq1,unsigned int speed)
{
l=0;
licznik=0;
delay=speed;		//ustawienie parametrw modulacji
gfreq1=freq1;
setphs(0);
gphs1=0;
gmode=12;
lcdclr();
lcdtxt("DBPSK");
lcdxy(0,1);
sprntf(temp,"%i",freq1);
lcdtxt("fn:");
lcdtxt(temp);
lcdtxt("Hz");
AT91C_BASE_TC1->TC_CCR = AT91C_TC_CLKEN;			//wlaczenie sygnalu zegarowego
AT91C_BASE_TC1->TC_CCR = AT91C_TC_SWTRG ;	
}



void qam16(unsigned long freq1,unsigned int speed)
{
l=0;
licznik=0;
delay=speed;
gfreq1=freq1;		//ustawienie parametrw modulacji
gmode=10;
lcdclr();
lcdtxt("16-QAM");
lcdxy(0,1);
sprntf(temp,"%i",freq1);
lcdtxt("fn:");
lcdtxt(temp);
lcdtxt("Hz");

AT91C_BASE_TC1->TC_CCR = AT91C_TC_CLKEN;			//wlaczenie sygnalu zegarowego
AT91C_BASE_TC1->TC_CCR = AT91C_TC_SWTRG ;			//odpalenie timera
}


void qam8(unsigned long freq1,unsigned int speed)
{
l=0;
licznik=0;
delay=speed;		//ustawienie parametrw modulacji
gfreq1=freq1;
gmode=11;
lcdclr();
lcdtxt("8-QAM");
lcdxy(0,1);
sprntf(temp,"%i",freq1);
lcdtxt("fn:");
lcdtxt(temp);
lcdtxt("Hz");
AT91C_BASE_TC1->TC_CCR = AT91C_TC_CLKEN;			//wlaczenie sygnalu zegarowego
AT91C_BASE_TC1->TC_CCR = AT91C_TC_SWTRG ;			//odpalenie timera
}

void init_rampfsk(unsigned long freq1,unsigned long freq2,unsigned long step,unsigned long speed)
{
wyslij(7);			//tryb pracy - ramped FSK
wyslij(16);			//wysanie danych konfigurujcych synteze
wyslij(75);
wyslij(21);
wyslij(96);
lcdclr();
lcdtxt("Ramped FSK X1");
setramprate(speed);		//ustawienie parametrw modulacji
setfreq(freq1);
setfreq2(freq2);
setdeltafreq(step);
amplituda(gamp);

}

void init_bpsk_pin(unsigned long freq1,unsigned int phs1,unsigned int phs2)
{
wyslij(7);			//tryb pracy - sprztowy BPSK
wyslij(16);			//wysanie danych konfigurujcych synteze
wyslij(75);
wyslij(25);
wyslij(96);
lcdclr();
lcdtxt("BPSK-gniazdo X1");
lcdxy(0,1);
sprntf(temp,"%i",freq1);
lcdtxt("fn:");
lcdtxt(temp);
lcdtxt("Hz");

setfreq(freq1);		//ustawienie parametrw modulacji
setphs(phs1);
setphs(phs2);
}


void qpsk(unsigned long freq1, unsigned int speed)
{
l=0;
licznik=0;
delay=speed;		//ustawienie parametrw modulacji
gfreq1=freq1;
gmode=8;
lcdclr();
lcdtxt("QPSK");
lcdxy(0,1);
lcdtxt("fn:");
sprntf(temp,"%i",freq1);
lcdtxt(temp);
lcdtxt("Hz");

AT91C_BASE_TC1->TC_CCR = AT91C_TC_CLKEN;			//wlaczenie sygnalu zegarowego
AT91C_BASE_TC1->TC_CCR = AT91C_TC_SWTRG ;			//odpalenie timera
}

void psk(unsigned long freq1,unsigned int phs1,unsigned int phs2,unsigned int speed)
{
l=0;
licznik=0;		//ustawienie parametrw modulacji
gphs1=phs1;
gphs2=phs2;
gfreq1=freq1;
delay=speed;
gmode=5;
lcdclr();
lcdtxt("PSK ");					//wywietlenie danych na wywietlaczu LCD
sprntf(temp,"%i",freq1);
lcdtxt(temp);
lcdtxt("Hz");
lcdxy(0,1);
lcdtxt("P0 ");
sprntf(temp,"%i",phs1);
lcdtxt(temp);

lcdtxt("  P1 ");
sprntf(temp,"%i",phs2);
lcdtxt(temp);
lcdtxt(" ");

AT91C_BASE_TC1->TC_CCR = AT91C_TC_CLKEN;			//wlaczenie sygnalu zegarowego
AT91C_BASE_TC1->TC_CCR = AT91C_TC_SWTRG ;			//odpalenie timera

}


void ask(unsigned long freq1,unsigned int amp1,unsigned int amp2, unsigned int speed)
{
l=0;
licznik=0;
gmode=4;
delay=speed;		//ustawienie parametrw modulacji
gamp1=amp1;
gamp2=amp2;
lcdclr();
lcdtxt("ASK ");
sprntf(temp,"%i",freq1);
lcdtxt(temp);
lcdtxt("Hz");			//wyswietlenie danych an wywietlaczu
lcdxy(0,1);
lcdtxt("A0 ");
sprntf(temp,"%i",amp1);
lcdtxt(temp);

lcdtxt("  A1 ");
sprntf(temp,"%i",amp2);
lcdtxt(temp);
lcdtxt(" ");

amplituda(0);
setfreq(freq1);

AT91C_BASE_TC1->TC_CCR = AT91C_TC_CLKEN;			//wlaczenie sygnalu zegarowego
AT91C_BASE_TC1->TC_CCR = AT91C_TC_SWTRG ;			//odpalenie timera

}

void fsk(unsigned long freq1,unsigned long freq2,unsigned int speed)
{
l=0;
licznik=0;
delay=speed;		//ustawienie parametrw modulacji
gfreq1=freq1;
gfreq2=freq2;
gmode=3;
lcdclr();
lcdtxt("FSK0 ");
sprntf(temp,"%i",freq1);
lcdtxt(temp);
lcdtxt("Hz");			//wyswietlenie danych na wyswietlaczu
lcdxy(0,1);
lcdtxt("1 ");
sprntf(temp,"%i",freq2);
lcdtxt(temp);
lcdtxt("Hz");

AT91C_BASE_TC1->TC_CCR = AT91C_TC_CLKEN;			//wlaczenie sygnalu zegarowego
AT91C_BASE_TC1->TC_CCR = AT91C_TC_SWTRG ;			//odpalenie timera
}

void sweep(unsigned long freq1,unsigned long freq2,unsigned long step,unsigned int speed)
{
gmode=2;			
gfreq=freq1;
delay=speed;			//parametry pracy wobulatora
gstep=step;
gfreq2=freq2;
lcdclr();
lcdtxt("SWP f1=");
sprntf(temp,"%i",freq1);
lcdtxt(temp);
lcdxy(0,1);
lcdtxt("f2= ");
sprntf(temp,"%i",freq1);
lcdtxt(temp);
AT91C_BASE_TC1->TC_CCR = AT91C_TC_CLKEN;
AT91C_BASE_TC1->TC_CCR = AT91C_TC_SWTRG ;			//odpalenie timera1
	
}

void timer1_int(void)					//obsuga przerwania od timera 1
{
unsigned char synch=0;
static unsigned int temp1;
static unsigned char temp2;
unsigned char temp3;
static char ii=1;
AT91PS_PIO p_pPio = AT91C_BASE_PIOA;
static unsigned int tcount=0;
AT91PS_TC TC_pt = AT91C_BASE_TC1;
static unsigned int arbl=0;
unsigned int status;

status = TC_pt->TC_SR;			//odczytanie rejestru statusowego (przyjecie obsugi przewrania)
status = status;				//usuniecie ostrzezenia o nieuzywanej zmiennej

if (tcount>=delay)				//odmierzenie zadanego przez parametry modulacji czasu
{
	

if (gmode==2)			//sweep
	{
	if (gfreq>gfreq2)						//jesli wobulator osiagnal gorna granice to 
	TC_pt->TC_CCR = AT91C_TC_CLKDIS ;		//wyacznie timera 1
	setfreq(gfreq);							//jesli nie to kontynuuj zwikszanie czestotliwoci
	if (ii==254)
	setp14;
	if (ii==1)
	clrp14;
	ii=~ii;	

	gfreq=gfreq+gstep;
	}

if (gmode==3)			//fsk
	{
	
	if (gdane[licznik]==0) 				//jeli dane to logiczne zero
	{	
	setfreq(gfreq1);						//ustaw czestotliwo gfreq1
	setp14;									//stan NISKI na wyjciu synchronizacyjnym
	}
	
	
	if (gdane[licznik]==1) 				//jeli dane to logiczne zero
	{										
	setfreq(gfreq2);						//ustaw czestotliwo gfreq1
	clrp14;									//stan WYSOKI na wyjciu synchronizacyjnym
	}
	

		if (licznik==16)					//wyslano caly bufor
		{
		clrp14;								//stan NISKI na wyjciu synchronizacyjnym						
		TC_pt->TC_CCR = AT91C_TC_CLKDIS;	//wyczenie timera
		licznik=-1;							//wskaznik tablicy =-1
		setfreq(0);							//wyczenie syntezy
		}
	licznik++;								//wskaznik tablicy =0
	}
	
	
if (gmode==4)			//ask
	{
	if (gdane[licznik]==0) {amplituda(gamp1);setp14;} 	//wysyanie danych jak wyej
	if (gdane[licznik]==1) {amplituda(gamp2);clrp14;}		//wysyanie danych jak wyej


		if (licznik==16)						//wyslano caly bufor
		{
		clrp14;
		TC_pt->TC_CCR = AT91C_TC_CLKDIS ;		//jak dla funkcji FSK
		licznik=-1;								
		setfreq(0);								//wyczenie syntezy
		}
	licznik++;
	}
	
if (gmode==5)			//psk
	{
	if (czy==0)		//ustawienie czestotliwosci nosnej tylko raz
	{
	czy=1;
	setfreq(gfreq1);
	}
	
	if (gdane[licznik]==0) {setphs(gphs1);setp14;}	//jak dla funkcji FSK
	if (gdane[licznik]==1) {setphs(gphs2);clrp14;}	//jak dla funkcji FSK


		if (licznik==16)			//wyslano caly bufor
		{
		clrp14;
		TC_pt->TC_CCR = AT91C_TC_CLKDIS ;		//jak dla funkcji FSK
		licznik=-1;
		setfreq(0);	
		czy=0;							//jak dla funkcji FSK
		}
	licznik++;
	}	
	

if (gmode==6)			//FM
	{
		licznik=(int)l;				//nr komorki tablicy sinusa dla programowego dds'a			
		setfreq(out[licznik]);
		l=l+speedfm;					//programowy dds, l - akumulator fazy
		if (l>143) l=0;				//speedfm - przyrost fazy 
	}
	
if (gmode==7)			//AM
	{
		licznik=(int)l;				//nr komorki tablicy sinusa dla programowego dds'a	
		amplituda(out[licznik]);		//programowy dds, l - akumulator fazy
		l=l+speedam;					//speedam - przyrost fazy 
		if (l>143) l=0;
	}

if (gmode==8)			//qpsk
	{
	if (czy==0)		//ustawienie czestotliwosci nosnej tylko raz
	{
	czy=1;
	setfreq(gfreq1);
	}
	
	
	if ((gdane[licznik]==0)&&(gdane[licznik+1]==0)) {setphs(225);synch=1;}	//konstelacja danych QPSK
	if ((gdane[licznik]==0)&&(gdane[licznik+1]==1)) {setphs(135);synch=2;}
	if ((gdane[licznik]==1)&&(gdane[licznik+1]==0)) {setphs(315);synch=3;}
	if ((gdane[licznik]==1)&&(gdane[licznik+1]==1)) {setphs(45);synch=4;}
	clrp14;
	/*if (licznik<32)							//obsuga zcza synchronizacyjnego
	{
	for (temp3=0;temp3<synch;temp3++)		//liczba impulsw na zczu 
	{										//okrela ktr dwjk bitw transmituje urzdzenie
	setp14;
	_delay(25+3*delay);						//generacja impulsw
	clrp14;
	_delay(25+3*delay);
	}
	}*/
	
	
	if (ii==254)
	setp14;
	if (ii==1)
	clrp14;
	ii=~ii;	

		if (licznik==32)			//wyslano caly bufor
		{
		setfreq(0);
		setp2;  //IO update
		clrp2;	
		ii=254;
		TC_pt->TC_CCR = AT91C_TC_CLKDIS ;
		clrp14;
		licznik=-2;					//licznik rwny -2 
		lcdxy(8,0);
		lcdtxt("Stop");
		czy=0;
		}
	licznik=licznik+2;
	
	}	

	if (gmode==9)			//tryb generatora arbitralnego
	{
	arbl++;					//wskaznik tablicy z probkami przebiegu
	temp1=arb[arbl];		//pobranie wartoci przebiegu z tablicy arb
	temp2=temp1;			//rozbicie wartosci 16 bit na dwie wartosci 8 bitowe
	temp1=temp1>>8;			
	wyslij(11);				//adres rejestru QDAC sytezy	
	wyslij(temp1);			//wysanie obu bajtw
	wyslij(temp2);
	setp2;  				//IO update
	clrp2;
	clrp14;
	if (arb[arbl+1]==0) arbl=0;		//wyzerowanie licznika za pomoc prbki o wartoci 0
	if (arbl>25) setp14;
	if (arbl>1023) arbl=0;
	}

	if (gmode==10)				//16-qam
	{
	if (czy==0)
	{
	czy=1;
	setfreq(gfreq1);
	
	}
	//clrp14;
	
	if (licznik<29) {
	//konstelacja 16-qam
	if ((gdane[licznik]==0)&&(gdane[licznik+1]==0)&&(gdane[licznik+2]==0)&&(gdane[licznik+3]==0)) {amplituda(4095); setphs(135);synch=1;}
	if ((gdane[licznik]==0)&&(gdane[licznik+1]==0)&&(gdane[licznik+2]==0)&&(gdane[licznik+3]==1)) {amplituda(3051); setphs(161);synch=2;}
	if ((gdane[licznik]==0)&&(gdane[licznik+1]==0)&&(gdane[licznik+2]==1)&&(gdane[licznik+3]==0)) {amplituda(4095); setphs(225);synch=3;}
	if ((gdane[licznik]==0)&&(gdane[licznik+1]==0)&&(gdane[licznik+2]==1)&&(gdane[licznik+3]==1)) {amplituda(3051); setphs(199);synch=4;}
	
	if ((gdane[licznik]==0)&&(gdane[licznik+1]==1)&&(gdane[licznik+2]==0)&&(gdane[licznik+3]==0)) {amplituda(3051); setphs(109);synch=5;}
	if ((gdane[licznik]==0)&&(gdane[licznik+1]==1)&&(gdane[licznik+2]==0)&&(gdane[licznik+3]==1)) {amplituda(1366); setphs(135);synch=6;}
	if ((gdane[licznik]==0)&&(gdane[licznik+1]==1)&&(gdane[licznik+2]==1)&&(gdane[licznik+3]==0)) {amplituda(3051); setphs(251);synch=7;}
	if ((gdane[licznik]==0)&&(gdane[licznik+1]==1)&&(gdane[licznik+2]==1)&&(gdane[licznik+3]==1)) {amplituda(1366); setphs(225);synch=8;}
	
	if ((gdane[licznik]==1)&&(gdane[licznik+1]==0)&&(gdane[licznik+2]==0)&&(gdane[licznik+3]==0)) {amplituda(4095); setphs(45);synch=9;}
	if ((gdane[licznik]==1)&&(gdane[licznik+1]==0)&&(gdane[licznik+2]==0)&&(gdane[licznik+3]==1)) {amplituda(3051); setphs(19);synch=10;}
	if ((gdane[licznik]==1)&&(gdane[licznik+1]==0)&&(gdane[licznik+2]==1)&&(gdane[licznik+3]==0)) {amplituda(4095); setphs(315);synch=11;}
	if ((gdane[licznik]==1)&&(gdane[licznik+1]==0)&&(gdane[licznik+2]==1)&&(gdane[licznik+3]==1)) {amplituda(3051); setphs(341);synch=12;}
	
	if ((gdane[licznik]==1)&&(gdane[licznik+1]==1)&&(gdane[licznik+2]==0)&&(gdane[licznik+3]==0)) {amplituda(3051); setphs(71);synch=13;}
	if ((gdane[licznik]==1)&&(gdane[licznik+1]==1)&&(gdane[licznik+2]==0)&&(gdane[licznik+3]==1)) {amplituda(1366); setphs(45);synch=14;}
	if ((gdane[licznik]==1)&&(gdane[licznik+1]==1)&&(gdane[licznik+2]==1)&&(gdane[licznik+3]==0)) {amplituda(3051); setphs(289);synch=15;}
	if ((gdane[licznik]==1)&&(gdane[licznik+1]==1)&&(gdane[licznik+2]==1)&&(gdane[licznik+3]==1)) {amplituda(1366); setphs(315);synch=16;}
	
	}

	
if (licznik!=32) {
	if (ii==254)
	setp14;
	
	
	
	if (ii==1)
	clrp14;
	

	ii=~ii;	
}

	/*	if (licznik<32)				//generacja impulsw synchronizacyjnych
		{
		for (temp3=0;temp3<synch;temp3++)
		{
		setp14;
		_delay(25+3*delay);	
		clrp14;
		_delay(25+3*delay);	
		}
		}*/


		if (licznik==32)			//wyslano caly bufor
		{
		clrp14;
		setfreq(0);
		setp2;  //IO update
		clrp2;
		ii=254;
		TC_pt->TC_CCR = AT91C_TC_CLKDIS ;
		licznik=-4;
		lcdxy(8,0);
		lcdtxt("Stop");
		uart1SendByte('k');			//koniec transmisji 16-qam
		czy=0;
		}
	licznik=licznik+4;
	}
	
	if (gmode==11)			//8-qam
	{
	if (czy==0)
	{
	czy=1;
	setfreq(gfreq1);
	}
	
	if (licznik<32) 
	{
	//konstelacja 8-qam
	if ((gdane[licznik]==0)&&(gdane[licznik+1]==0)&&(gdane[licznik+2]==0)){setphs(180); amplituda(4095);synch=1;}
	if ((gdane[licznik]==0)&&(gdane[licznik+1]==0)&&(gdane[licznik+2]==1)){setphs(135); amplituda(2118);synch=2;}
	if ((gdane[licznik]==0)&&(gdane[licznik+1]==1)&&(gdane[licznik+2]==0)){setphs(225); amplituda(2118);synch=3;}
	if ((gdane[licznik]==0)&&(gdane[licznik+1]==1)&&(gdane[licznik+2]==1)){setphs(90); amplituda(4095);synch=4;} 
	if ((gdane[licznik]==1)&&(gdane[licznik+1]==0)&&(gdane[licznik+2]==0)){setphs(270); amplituda(4095);synch=5;} 
	if ((gdane[licznik]==1)&&(gdane[licznik+1]==0)&&(gdane[licznik+2]==1)){setphs(45); amplituda(2118);synch=6;} 
	if ((gdane[licznik]==1)&&(gdane[licznik+1]==1)&&(gdane[licznik+2]==0)){setphs(315); amplituda(2118);synch=7;} 
	if ((gdane[licznik]==1)&&(gdane[licznik+1]==1)&&(gdane[licznik+2]==1)){setphs(0); amplituda(4095);synch=8;} 
	}

		/*if (licznik<33)				//generacja impulsw synchronizacyjnych
		{
		for (temp3=0;temp3<synch;temp3++)
		{
		setp14;
		_delay(25+3*delay);	
		clrp14;
		_delay(25+3*delay);	
		}
		}*/


	if (ii==254)
	setp14;
	
	
	
	if (ii==1)
	clrp14;
	

	ii=~ii;	


		if (licznik==33)			//wyslano caly bufor
		{
		TC_pt->TC_CCR = AT91C_TC_CLKDIS ;
		licznik=-3;
		setfreq(0);
		setp2;  //IO update
		clrp2;
		ii=254;
		clrp14;
		lcdxy(8,0);
		lcdtxt("Stop");
		uart1SendByte('l');		//koniec transmisji 8-qam
		czy=0;
		}
	licznik=licznik+3;
	}
	
	if (gmode==12)			//dbpsk
	{
	if (czy==0)			//wlaczenie czstotlwosci nonej
	{
	czy=1;
	setfreq(gfreq1);
	setp14;
	}
	
	if (licznik<32) 
	{
	
	
	if (gdane[licznik]==1)		//jeli dana wejciowa to "1" to 
		{
		gphs1=gphs1+180;		//zmien faz przebiegu o 180 stopni
		gphs1=gphs1%360;		//aby nie przekroczyc zakresu kat bedzie z zakresu 0-360
		setphs(gphs1);
		clrp14;					//stan WYSOKI - gniazdo synchronizacja
		}
	
	
	if (gdane[licznik]==0) setp14;
		}

		if (licznik==32)			//wyslano caly bufor
		{
		TC_pt->TC_CCR = AT91C_TC_CLKDIS;	//wycznie timera 1
		licznik=-1;
		setfreq(0);				//wyczenie syntezy
		clrp14;					//stan NISKI - gniazdo synchronizacja
		czy=0;
		lcdxy(8,0);
		lcdtxt("Stop");
		}
	licznik=licznik+1;
	}
	
	
	static unsigned long int fhssf=0;
	
	if (gmode==13)				//FHSS z BPSK
	{
	if (czy==0)
	{
	czy=1;
	fhssf=gfreq1;				//przepisanie czestotliwosci nosnej do nowej zmiennej
	clrp14;
	}
	
	
	if (licznik<16) 
	{
	if (gdane[licznik]==1) setphs(180);	//modulacja BPSK
	if (gdane[licznik]==0) setphs(0);
	setfreq(fhssf);					//wlaczenie fali nosnej
	fhssf=fhssf+gstep;				//skok czestotliwosci
	}
		if (licznik==15)			//wyslano caly bufor
		{
		licznik=-1;
		clrp14;						//stan NISKI na gniezdzie synchronizacja
		czy=0;
		}
	licznik=licznik+1;
	}
	
	if (gmode==14)					//FHSS z ASK
	{
	if (czy==0)
	{
	czy=1;
	fhssf=gfreq1;
	clrp14;							//stan WYSOKI na gniezdzie synchronizacja
	}
	
	
	if (licznik<16) 
	{
	if (gdane[licznik]==1) amplituda(4095);	//modulacja 2-ASK
	if (gdane[licznik]==0) amplituda(2048);
	setfreq(fhssf);								//wczenie fali nonej
	fhssf=fhssf+gstep;							//skok czstotliwoci
	}
		if (licznik==15)			//wyslano caly bufor
		{
		licznik=-1;
		clrp14;						//stan NISKI na gniezdzie synchronizacja
		czy=0;
		}
	licznik=licznik+1;
	}
	
	
tcount=0;
}
tcount++;
}

void AT91F_TC_Open ( AT91PS_TC TC_pt, unsigned int Mode, unsigned int TimerId)
{
 unsigned int status;
    //wczenie sygnau taktujcego dla timera1
    	AT91F_PMC_EnablePeriphClock ( AT91C_BASE_PMC, 1<< TimerId ) ;
		//wyczyszczenie bitu statusu
        status = TC_pt->TC_SR;
		//usuniecie ostrzezenia o nieuzywanej zmiennej
		status = status;
		AT91C_BASE_TC1->TC_IER  = 1<<4;		//odblokowanie przerwania
		AT91C_BASE_TC1->TC_IMR  = 1<<4;
		TC_pt->TC_CMR=1<<15|1<<14; 			//ustawienie trybu pracy timera1
		TC_pt->TC_RC=912;						//fclk = 30khz okreslony przez gorna granice zliczania
		TC_pt->TC_CCR = AT91C_TC_CLKEN ;		//wlaczenie timera
}

void uart1przerwanie(void)						//obsuga przerwania od RS-232
{
AT91PS_TC TC_pt = AT91C_BASE_TC1;
AT91PS_PIO p_pPio = AT91C_BASE_PIOA; 
static unsigned char buf[2050];
char data=0,a,b,c,d;
static unsigned int x=0;
static char czyarb=0;
static unsigned int arbl=0;
unsigned long freq1=0;
unsigned long freq2=0;
unsigned int amp1=0;
unsigned int speed=0;
unsigned int amp2=0;
unsigned long step=0;
unsigned int phs1=0;
unsigned int phs2=0;

data=uart1GetByte();				//odczyt danych

if (czyarb==0)						//czy tryb pracy to generator arbitralny 0 = nie
{

if (data=='r') 					//reset syntezy 		
{

setp0;		//reset
clrp0;
lcdclr();
lcdtxt("RESET");
longdelay();
lcdclr();
lcdtxt("Gotowy");

}

if (data=='i') 					//inicjalizacja syntezy
{
setp0;//reset
clrp0;
init_dds();
lcdclr();
lcdtxt("Gotowy");
pot=13.78615;					//warto potrzebna do przeliczenia czestotliwosc - FTW1
}								//PLL 11 razy

if (data=='+') 
{
setp0;//reset
clrp0;
wyslij(7);						//inicjalizacja syntezy z wyczonym PLL'em
wyslij(16);
wyslij(32);
wyslij(16);
wyslij(96);
setp2; //ioud
clrp2;
lcdclr();
lcdtxt("Gotowy");
pot=151.64765;				//warto potrzebna do przeliczenia czestotliwosc - FTW1
}							//PLL wyczony



}

if ((data==109)&(czyarb==0))
{
czyarb=1; 	
x=0;		//wlacznie trybu arbitralnego szybkiego fclk=30kHz
delay=0;
}

if ((data==66)&(czyarb==0))
{
czyarb=1; 
x=0;		//wlacznie trybu arbitralnego wolnego fclk=3kHz
delay=10;
}



x++;
buf[x]=data;

if (flaga>0) 					//dowolny kod do wylaczenia flagi, b.duze opciazenie CPU
flaga=0;						//flaga okrelajca prace w modulacjach analogowych (petla while)
TC_pt->TC_CCR = AT91C_TC_CLKDIS ;	//wyczenie timera1

if (czyarb==0)
{
if (buf[x]==100)				//litera d, wylacz synteze
{
TC_pt->TC_CCR = AT91C_TC_CLKDIS ;

if (pot<14) init_dds();		//jesli tryb pracy z PLL to domysla inicjalizacja
if (pot>14) 					//jesli nie to inicjalizacja z wyaczonym PLL
	{
	wyslij(7);
	wyslij(16);
	wyslij(32);
	wyslij(16);
	wyslij(96);
	setp2; //ioud
	clrp2;
	}

flaga=0;
czy=0;
setfreq(0);						//wyczenie syntezy
setphs(0);
amplituda(gamp);
for (int y=0;y<1026;y++)		//wyczyszczenie bufora danych RS-232
	buf[y]=0;
	
l=0;
gmode=0;
x=0;
data=0;
lcdclr();
lcdtxt("Gotowy");
}	
}

		
if (czyarb==1) 
{
if (x>2048) 					//tryb arbitralny
	{
	
		for (arbl=1;arbl<1026;arbl++)					//wysanie 1024 probek
		arb[arbl]=(256*buf[2*arbl])+buf[2*arbl+1];	//w formie 2 razy po 8 bitow
	
	arbl=0;				//wyzerowanie wskaznika tablicy
	czyarb=0;			//sygnalizacja ze mona wyjsc z trybu arbitralnego 
	x=0;
	gmode=9;
	amplituda(4095);	//amplituda maksymalna
	lcdclr();
	lcdtxt("Gen. arbitralny");
	AT91C_BASE_TC1->TC_CCR = AT91C_TC_CLKEN;			//wlaczenie sygnalu zegarowego
	AT91C_BASE_TC1->TC_CCR = AT91C_TC_SWTRG ;			//odpalenie timera
	}
	}


if ((buf[x]==101)&&(czyarb==0)) 			//litera e, koniec wysylania danych
	{


if (buf[1]==65)    					//litera A, FHSS - ASK
	{
	freq1=buf[2]-48;					//odczytywanie kolejnych pl z bufora RS-232
	freq1=freq1+(buf[3]-48)*10;
	freq1=freq1+(buf[4]-48)*100;
	freq1=freq1+(buf[5]-48)*1000;
	freq1=freq1+(buf[6]-48)*10000;
	freq1=freq1+(buf[7]-48)*100000;
	freq1=freq1+(buf[8]-48)*1000000;
	freq1=freq1+(buf[9]-48)*10000000;
	freq1=freq1+(buf[10]-48)*100000000;
	
	gtc=buf[11]-48;
	gtc=gtc+(buf[12]-48)*10;
	gtc=gtc+(buf[13]-48)*100;
	gtc=gtc+(buf[14]-48)*1000;
	gtc=gtc+(buf[15]-48)*10000;
		
	step=buf[16]-48;
	step=step+(buf[17]-48)*10;				
	step=step+(buf[18]-48)*100;
	step=step+(buf[19]-48)*1000;
	step=step+(buf[20]-48)*10000;
	step=step+(buf[21]-48)*100000;
	step=step+(buf[22]-48)*1000000;
	step=step+(buf[23]-48)*10000000;
	step=step+(buf[24]-48)*100000000;
	
	for (char y=25;y<41;y++)
	gdane[y-25]=buf[y]-48;
	fhssask(freq1,gtc,step);
	
	}



if (buf[1]==106)    				//litera j, FHSS - BPSK
	{
	freq1=buf[2]-48;					//odczytywanie kolejnych pl z bufora RS-232
	freq1=freq1+(buf[3]-48)*10;
	freq1=freq1+(buf[4]-48)*100;
	freq1=freq1+(buf[5]-48)*1000;
	freq1=freq1+(buf[6]-48)*10000;
	freq1=freq1+(buf[7]-48)*100000;
	freq1=freq1+(buf[8]-48)*1000000;
	freq1=freq1+(buf[9]-48)*10000000;
	freq1=freq1+(buf[10]-48)*100000000;
	
	gtc=buf[11]-48;					//odczytywanie kolejnych pl z bufora RS-232
	gtc=gtc+(buf[12]-48)*10;
	gtc=gtc+(buf[13]-48)*100;
	gtc=gtc+(buf[14]-48)*1000;
	gtc=gtc+(buf[15]-48)*10000;
	
	
	step=buf[16]-48;					//odczytywanie kolejnych pl z bufora RS-232
	step=step+(buf[17]-48)*10;				
	step=step+(buf[18]-48)*100;
	step=step+(buf[19]-48)*1000;
	step=step+(buf[20]-48)*10000;
	step=step+(buf[21]-48)*100000;
	step=step+(buf[22]-48)*1000000;
	step=step+(buf[23]-48)*10000000;
	step=step+(buf[24]-48)*100000000;
	
	for (char y=25;y<41;y++)
	gdane[y-25]=buf[y]-48;
	fhssbpsk(freq1,gtc,step);
	
	}


if (buf[1]==113)    				//litera q, DBPSK
	{
	freq1=buf[2]-48;					//odczytywanie kolejnych pl z bufora RS-232
	freq1=freq1+(buf[3]-48)*10;
	freq1=freq1+(buf[4]-48)*100;
	freq1=freq1+(buf[5]-48)*1000;
	freq1=freq1+(buf[6]-48)*10000;
	freq1=freq1+(buf[7]-48)*100000;
	freq1=freq1+(buf[8]-48)*1000000;
	freq1=freq1+(buf[9]-48)*10000000;
	freq1=freq1+(buf[10]-48)*100000000;
	
	speed=buf[11]-48;					//odczytywanie kolejnych pl z bufora RS-232
	speed=speed+(buf[12]-48)*10;
	speed=speed+(buf[13]-48)*100;
	speed=speed+(buf[14]-48)*1000;
	speed=speed+(buf[15]-48)*10000;
	for (char y=16;y<49;y++)
	gdane[y-16]=buf[y]-48;
	dbpsk(freq1,speed);
	
	}

	if (buf[1]==115)    				//litera s, 8-qam
	{
	freq1=buf[2]-48;					//odczytywanie kolejnych pl z bufora RS-232
	freq1=freq1+(buf[3]-48)*10;
	freq1=freq1+(buf[4]-48)*100;
	freq1=freq1+(buf[5]-48)*1000;
	freq1=freq1+(buf[6]-48)*10000;
	freq1=freq1+(buf[7]-48)*100000;
	freq1=freq1+(buf[8]-48)*1000000;
	freq1=freq1+(buf[9]-48)*10000000;
	freq1=freq1+(buf[10]-48)*100000000;
	
	speed=buf[11]-48;					//odczytywanie kolejnych pl z bufora RS-232
	speed=speed+(buf[12]-48)*10;
	speed=speed+(buf[13]-48)*100;
	speed=speed+(buf[14]-48)*1000;
	speed=speed+(buf[15]-48)*10000;
	for (char y=16;y<49;y++)
	gdane[y-16]=buf[y]-48;
	qam8(freq1,speed);
	
	}
	
	
	
	if (buf[1]==116)    				//litera t, 16-qam
	{
	freq1=buf[2]-48;					//odczytywanie kolejnych pl z bufora RS-232
	freq1=freq1+(buf[3]-48)*10;
	freq1=freq1+(buf[4]-48)*100;
	freq1=freq1+(buf[5]-48)*1000;
	freq1=freq1+(buf[6]-48)*10000;
	freq1=freq1+(buf[7]-48)*100000;
	freq1=freq1+(buf[8]-48)*1000000;
	freq1=freq1+(buf[9]-48)*10000000;
	freq1=freq1+(buf[10]-48)*100000000;
	
	speed=buf[11]-48;					//odczytywanie kolejnych pl z bufora RS-232
	speed=speed+(buf[12]-48)*10;
	speed=speed+(buf[13]-48)*100;
	speed=speed+(buf[14]-48)*1000;
	speed=speed+(buf[15]-48)*10000;
	for (char y=16;y<48;y++)
	gdane[y-16]=buf[y]-48;
	qam16(freq1,speed);
	
	}
	
	
	if (buf[1]==119)		//litera w, sprzetowa modulacja PM z ADC
	{
	freq1=buf[2]-48;					//odczytywanie kolejnych pl z bufora RS-232
	freq1=freq1+(buf[3]-48)*10;
	freq1=freq1+(buf[4]-48)*100;
	freq1=freq1+(buf[5]-48)*1000;
	freq1=freq1+(buf[6]-48)*10000;
	freq1=freq1+(buf[7]-48)*100000;
	freq1=freq1+(buf[8]-48)*1000000;
	freq1=freq1+(buf[9]-48)*10000000;
	freq1=freq1+(buf[10]-48)*100000000;
	setfreq(freq1);
	amplituda(gamp);
	lcdclr();
	lcdtxt("PM-gniazdo X3");
	lcdxy(0,1);
	sprntf(temp,"%i",freq1);
	lcdtxt("fn=");
	lcdtxt(temp);
	lcdtxt("Hz");
	flaga=3;
	}
	
	
	
	
	if (buf[1]==107)		//litera k, sprzetowy ramped fsk ze zlacza x1
	{
	freq1=buf[2]-48;					//odczytywanie kolejnych pl z bufora RS-232
	freq1=freq1+(buf[3]-48)*10;
	freq1=freq1+(buf[4]-48)*100;
	freq1=freq1+(buf[5]-48)*1000;
	freq1=freq1+(buf[6]-48)*10000;
	freq1=freq1+(buf[7]-48)*100000;
	freq1=freq1+(buf[8]-48)*1000000;
	freq1=freq1+(buf[9]-48)*10000000;
	freq1=freq1+(buf[10]-48)*100000000;
	
	freq2=buf[11]-48;					//odczytywanie kolejnych pl z bufora RS-232
	freq2=freq2+(buf[12]-48)*10;
	freq2=freq2+(buf[13]-48)*100;
	freq2=freq2+(buf[14]-48)*1000;
	freq2=freq2+(buf[15]-48)*10000;
	freq2=freq2+(buf[16]-48)*100000;
	freq2=freq2+(buf[17]-48)*1000000;
	freq2=freq2+(buf[18]-48)*10000000;
	freq2=freq2+(buf[19]-48)*100000000;
	
	step=buf[20]-48;					//odczytywanie kolejnych pl z bufora RS-232
	step=step+(buf[21]-48)*10;				//step jako krok ramped FSK
	step=step+(buf[22]-48)*100;
	step=step+(buf[23]-48)*1000;
	step=step+(buf[24]-48)*10000;
	step=step+(buf[25]-48)*100000;
	step=step+(buf[26]-48)*1000000;
	step=step+(buf[27]-48)*10000000;
	step=step+(buf[28]-48)*100000000;
	
	gfreq2=buf[29]-48;					//odczytywanie kolejnych pl z bufora RS-232
	gfreq2=gfreq2+(buf[30]-48)*10;
	gfreq2=gfreq2+(buf[31]-48)*100;
	gfreq2=gfreq2+(buf[32]-48)*1000;
	gfreq2=gfreq2+(buf[33]-48)*10000;
	gfreq2=gfreq2+(buf[34]-48)*100000;
	gfreq2=gfreq2+(buf[35]-48)*1000000;
	
	init_rampfsk(freq1,freq2,step,gfreq2);
	
	}
	
	
	if (buf[1]==117)		//litera u, sprzetowy BPSK ze zlacza X1
	{
	freq1=buf[2]-48;					//odczytywanie kolejnych pl z bufora RS-232
	freq1=freq1+(buf[3]-48)*10;
	freq1=freq1+(buf[4]-48)*100;
	freq1=freq1+(buf[5]-48)*1000;
	freq1=freq1+(buf[6]-48)*10000;
	freq1=freq1+(buf[7]-48)*100000;
	freq1=freq1+(buf[8]-48)*1000000;
	freq1=freq1+(buf[9]-48)*10000000;
	freq1=freq1+(buf[10]-48)*100000000;
	
	phs1=buf[11]-48;					//odczytywanie kolejnych pl z bufora RS-232
	phs1=phs1+(buf[12]-48)*10;
	phs1=phs1+(buf[13]-48)*100;
	
	phs2=buf[14]-48;					//odczytywanie kolejnych pl z bufora RS-232
	phs2=phs2+(buf[15]-48)*10;
	phs2=phs2+(buf[16]-48)*100;
	
	init_bpsk_pin(freq1,phs1,phs2);
	
	}
	

	if (buf[1]==110)		//litera n, sprzetowy OOK ze zlacza X2 z ramp
	{
	freq1=buf[2]-48;					//odczytywanie kolejnych pl z bufora RS-232
	freq1=freq1+(buf[3]-48)*10;
	freq1=freq1+(buf[4]-48)*100;
	freq1=freq1+(buf[5]-48)*1000;
	freq1=freq1+(buf[6]-48)*10000;
	freq1=freq1+(buf[7]-48)*100000;
	freq1=freq1+(buf[8]-48)*1000000;
	freq1=freq1+(buf[9]-48)*10000000;
	freq1=freq1+(buf[10]-48)*100000000;
												//odczytywanie kolejnych pl z bufora RS-232
	phs1=buf[11]-48;							//phs1 jako ramp rate 
	phs1=phs1+(buf[12]-48)*10;
	phs1=phs1+(buf[13]-48)*100;
	
	init_osk_pin(freq1,phs1);
	
	}

	if (buf[1]==120)		//litera x, sprzetowy FSK ze zlacza X1
	{
	freq1=buf[2]-48;					//odczytywanie kolejnych pl z bufora RS-232
	freq1=freq1+(buf[3]-48)*10;
	freq1=freq1+(buf[4]-48)*100;
	freq1=freq1+(buf[5]-48)*1000;
	freq1=freq1+(buf[6]-48)*10000;
	freq1=freq1+(buf[7]-48)*100000;
	freq1=freq1+(buf[8]-48)*1000000;
	freq1=freq1+(buf[9]-48)*10000000;
	freq1=freq1+(buf[10]-48)*100000000;
	
	freq2=buf[11]-48;					//odczytywanie kolejnych pl z bufora RS-232
	freq2=freq2+(buf[12]-48)*10;
	freq2=freq2+(buf[13]-48)*100;
	freq2=freq2+(buf[14]-48)*1000;
	freq2=freq2+(buf[15]-48)*10000;
	freq2=freq2+(buf[16]-48)*100000;
	freq2=freq2+(buf[17]-48)*1000000;
	freq2=freq2+(buf[18]-48)*10000000;
	freq2=freq2+(buf[19]-48)*100000000;
	
	init_fsk_pin(freq1,freq2);
	
	
	}
	
	if (buf[1]==97)				//litera a, zmiana amplitudy
	{
	gamp=buf[2]-48;					//odczytywanie kolejnych pl z bufora RS-232
	gamp=gamp+(buf[3]-48)*10;
	gamp=gamp+(buf[4]-48)*100;
	gamp=gamp+(buf[5]-48)*1000;
		if (gmode==100) 
		{
		lcdxy(0,1);
		lcdtxt("A=");
		sprntf(temp,"%i",gamp);
		lcdtxt(temp);
		lcdtxt(" P=");
		sprntf(temp,"%i",gphs1);
		lcdtxt(temp);
		lcdtxt(" ");
		}
	amplituda(gamp);
	}

	if (buf[1]==49) 			//cyfra 1  tryb single tone
	{
	freq1=buf[2]-48;					//odczytywanie kolejnych pl z bufora RS-232
	freq1=freq1+(buf[3]-48)*10;
	freq1=freq1+(buf[4]-48)*100;
	freq1=freq1+(buf[5]-48)*1000;
	freq1=freq1+(buf[6]-48)*10000;
	freq1=freq1+(buf[7]-48)*100000;
	freq1=freq1+(buf[8]-48)*1000000;
	freq1=freq1+(buf[9]-48)*10000000;
	freq1=freq1+(buf[10]-48)*100000000;
	
	amp1=buf[11]-48;					//odczytywanie kolejnych pl z bufora RS-232
	amp1=amp1+(buf[12]-48)*10;
	amp1=amp1+(buf[13]-48)*100;
	amp1=amp1+(buf[14]-48)*1000;
	
	phs1=buf[15]-48;					//odczytywanie kolejnych pl z bufora RS-232
	phs1=phs1+(buf[16]-48)*10;
	phs1=phs1+(buf[17]-48)*100;

	gphs1=phs1;
	lcdclr();
	lcdtxt("Gen ");
	sprntf(temp,"%i",freq1);
	lcdtxt(temp);
	lcdtxt("Hz");
	lcdxy(0,1);
	lcdtxt("A=");
	sprntf(temp,"%i",amp1);
	lcdtxt(temp);
	lcdtxt(" P=");
	sprntf(temp,"%i",phs1);
	lcdtxt(temp);
	gmode=100; 							//single tone, znacznik dla regulacji amplitudy
	setfreq(freq1);
	amplituda(amp1);
	setphs(phs1);
	}

	if (buf[1]==50)    				//cyfra 2, tryb sweep
	{
	freq1=buf[2]-48;					//odczytywanie kolejnych pl z bufora RS-232
	freq1=freq1+(buf[3]-48)*10;
	freq1=freq1+(buf[4]-48)*100;
	freq1=freq1+(buf[5]-48)*1000;
	freq1=freq1+(buf[6]-48)*10000;
	freq1=freq1+(buf[7]-48)*100000;
	freq1=freq1+(buf[8]-48)*1000000;
	freq1=freq1+(buf[9]-48)*10000000;
	freq1=freq1+(buf[10]-48)*100000000;
	
	freq2=buf[11]-48;					//odczytywanie kolejnych pl z bufora RS-232
	freq2=freq2+(buf[12]-48)*10;
	freq2=freq2+(buf[13]-48)*100;
	freq2=freq2+(buf[14]-48)*1000;
	freq2=freq2+(buf[15]-48)*10000;
	freq2=freq2+(buf[16]-48)*100000;
	freq2=freq2+(buf[17]-48)*1000000;
	freq2=freq2+(buf[18]-48)*10000000;
	freq2=freq2+(buf[19]-48)*100000000;
	
	step=buf[20]-48;					//odczytywanie kolejnych pl z bufora RS-232
	step=step+(buf[21]-48)*10;
	step=step+(buf[22]-48)*100;
	step=step+(buf[23]-48)*1000;
	step=step+(buf[24]-48)*10000;
	step=step+(buf[25]-48)*100000;
	step=step+(buf[26]-48)*1000000;
	step=step+(buf[27]-48)*10000000;
	step=step+(buf[28]-48)*100000000;
	
	speed=buf[29]-48;					//odczytywanie kolejnych pl z bufora RS-232
	speed=speed+(buf[30]-48)*10;
	speed=speed+(buf[31]-48)*100;
	speed=speed+(buf[32]-48)*1000;
	speed=speed+(buf[33]-48)*10000;
	
	sweep(freq1,freq2,step,speed);
	}

	if (buf[1]==51)    				//cyfra 3, tryb FSK z danymi
	{
	freq1=buf[2]-48;					//odczytywanie kolejnych pl z bufora RS-232
	freq1=freq1+(buf[3]-48)*10;
	freq1=freq1+(buf[4]-48)*100;
	freq1=freq1+(buf[5]-48)*1000;
	freq1=freq1+(buf[6]-48)*10000;
	freq1=freq1+(buf[7]-48)*100000;
	freq1=freq1+(buf[8]-48)*1000000;
	freq1=freq1+(buf[9]-48)*10000000;
	freq1=freq1+(buf[10]-48)*100000000;
	
	freq2=buf[11]-48;					//odczytywanie kolejnych pl z bufora RS-232
	freq2=freq2+(buf[12]-48)*10;
	freq2=freq2+(buf[13]-48)*100;
	freq2=freq2+(buf[14]-48)*1000;
	freq2=freq2+(buf[15]-48)*10000;
	freq2=freq2+(buf[16]-48)*100000;
	freq2=freq2+(buf[17]-48)*1000000;
	freq2=freq2+(buf[18]-48)*10000000;
	freq2=freq2+(buf[19]-48)*100000000;
	
	speed=buf[20]-48;					//odczytywanie kolejnych pl z bufora RS-232
	speed=speed+(buf[21]-48)*10;
	speed=speed+(buf[22]-48)*100;
	speed=speed+(buf[23]-48)*1000;
	speed=speed+(buf[24]-48)*10000;
	
	for (char y=25;y<41;y++)
	gdane[y-25]=buf[y]-48;
	
	
	fsk(freq1,freq2,speed);
	}
	
	
	if (buf[1]==52) 			//cyfra 4 / tryb ASK z danymi
	{
	freq1=buf[2]-48;					//odczytywanie kolejnych pl z bufora RS-232
	freq1=freq1+(buf[3]-48)*10;
	freq1=freq1+(buf[4]-48)*100;
	freq1=freq1+(buf[5]-48)*1000;
	freq1=freq1+(buf[6]-48)*10000;
	freq1=freq1+(buf[7]-48)*100000;
	freq1=freq1+(buf[8]-48)*1000000;
	freq1=freq1+(buf[9]-48)*10000000;
	freq1=freq1+(buf[10]-48)*100000000;
	
	amp1=buf[11]-48;					//odczytywanie kolejnych pl z bufora RS-232
	amp1=amp1+(buf[12]-48)*10;
	amp1=amp1+(buf[13]-48)*100;
	amp1=amp1+(buf[14]-48)*1000;
	
	amp2=buf[15]-48;					//odczytywanie kolejnych pl z bufora RS-232
	amp2=amp2+(buf[16]-48)*10;
	amp2=amp2+(buf[17]-48)*100;
	amp2=amp2+(buf[18]-48)*1000;
	
	speed=buf[19]-48;					//odczytywanie kolejnych pl z bufora RS-232
	speed=speed+(buf[20]-48)*10;
	speed=speed+(buf[21]-48)*100;
	speed=speed+(buf[22]-48)*1000;
	speed=speed+(buf[23]-48)*10000;

	for (char y=24;y<40;y++)
	gdane[y-24]=buf[y]-48;

	ask(freq1,amp1,amp2,speed);
	}
	
	
	if (buf[1]==53) 			//cyfra 5 / tryb PSK z danymi
	{
	freq1=buf[2]-48;
	freq1=freq1+(buf[3]-48)*10;
	freq1=freq1+(buf[4]-48)*100;
	freq1=freq1+(buf[5]-48)*1000;
	freq1=freq1+(buf[6]-48)*10000;
	freq1=freq1+(buf[7]-48)*100000;
	freq1=freq1+(buf[8]-48)*1000000;
	freq1=freq1+(buf[9]-48)*10000000;
	freq1=freq1+(buf[10]-48)*100000000;
	
	phs1=buf[11]-48;					//odczytywanie kolejnych pl z bufora RS-232
	phs1=phs1+(buf[12]-48)*10;
	phs1=phs1+(buf[13]-48)*100;
	
	phs2=buf[14]-48;					//odczytywanie kolejnych pl z bufora RS-232
	phs2=phs2+(buf[15]-48)*10;
	phs2=phs2+(buf[16]-48)*100;
	
	speed=buf[17]-48;					//odczytywanie kolejnych pl z bufora RS-232
	speed=speed+(buf[18]-48)*10;
	speed=speed+(buf[19]-48)*100;
	speed=speed+(buf[20]-48)*1000;
	speed=speed+(buf[21]-48)*10000;

	for (char y=22;y<38;y++)			//odczytywanie kolejnych pl z bufora RS-232
	gdane[y-22]=buf[y]-48;
	psk(freq1,phs1,phs2,speed);
	}
	
	if (buf[1]==54) 			//cyfra 6 modulacja FM (sinus) programowa
	{
	freq1=buf[2]-48;					//odczytywanie kolejnych pl z bufora RS-232
	freq1=freq1+(buf[3]-48)*10;
	freq1=freq1+(buf[4]-48)*100;
	freq1=freq1+(buf[5]-48)*1000;
	freq1=freq1+(buf[6]-48)*10000;
	freq1=freq1+(buf[7]-48)*100000;
	freq1=freq1+(buf[8]-48)*1000000;
	freq1=freq1+(buf[9]-48)*10000000;
	freq1=freq1+(buf[10]-48)*100000000;
	
	freq2=buf[11]-48;					//odczytywanie kolejnych pl z bufora RS-232
	freq2=freq2+(buf[12]-48)*10;
	freq2=freq2+(buf[13]-48)*100;
	freq2=freq2+(buf[14]-48)*1000;
	freq2=freq2+(buf[15]-48)*10000;
	freq2=freq2+(buf[16]-48)*100000;
	freq2=freq2+(buf[17]-48)*1000000;
	freq2=freq2+(buf[18]-48)*10000000;
	freq2=freq2+(buf[19]-48)*100000000;
	
	speed=buf[20]-48;					//odczytywanie kolejnych pl z bufora RS-232
	speed=speed+(buf[21]-48)*10;
	speed=speed+(buf[22]-48)*100;
	speed=speed+(buf[23]-48)*1000;
	speed=speed+(buf[24]-48)*10000;
	
	modulacjafm(freq1,freq2,speed);
	}
	
	
	if (buf[1]==55) 			//cyfra 7 modulacja AM (sinus) programowa
	{
	freq1=buf[2]-48;					//odczytywanie kolejnych pl z bufora RS-232
	freq1=freq1+(buf[3]-48)*10;
	freq1=freq1+(buf[4]-48)*100;
	freq1=freq1+(buf[5]-48)*1000;
	freq1=freq1+(buf[6]-48)*10000;
	freq1=freq1+(buf[7]-48)*100000;
	freq1=freq1+(buf[8]-48)*1000000;
	freq1=freq1+(buf[9]-48)*10000000;
	freq1=freq1+(buf[10]-48)*100000000;
	
	gdepth=buf[11]-48;					//odczytywanie kolejnych pl z bufora RS-232
	gdepth=gdepth+(buf[12]-48)*10;
	gdepth=gdepth+(buf[13]-48)*100;
	
	speed=buf[14]-48;					//odczytywanie kolejnych pl z bufora RS-232
	speed=speed+(buf[15]-48)*10;
	speed=speed+(buf[16]-48)*100;
	speed=speed+(buf[17]-48)*1000;
	speed=speed+(buf[18]-48)*10000;
	
	modulacjaam(freq1,gdepth,speed);
	}
	
	
	if (buf[1]==56)			//cyfra 8, modulacja AM sprzetowa z zewn. generatora
	{
	freq1=buf[2]-48;					//odczytywanie kolejnych pl z bufora RS-232
	freq1=freq1+(buf[3]-48)*10;
	freq1=freq1+(buf[4]-48)*100;
	freq1=freq1+(buf[5]-48)*1000;
	freq1=freq1+(buf[6]-48)*10000;
	freq1=freq1+(buf[7]-48)*100000;
	freq1=freq1+(buf[8]-48)*1000000;
	freq1=freq1+(buf[9]-48)*10000000;
	freq1=freq1+(buf[10]-48)*100000000;
	
	lcdclr();
	lcdtxt("AM-gniazdo X3");
	lcdxy(0,1);
	sprntf(temp,"%i",freq1);
	lcdtxt("fn=");
	lcdtxt(temp);
	lcdtxt("Hz");
	amplituda(gamp);
	setfreq(freq1);
	flaga=1;
	}
	
	if (buf[1]==57)			//cyfra 9, modulacja FM sprzetowa z zewn. generatora
	{
	freq1=buf[2]-48;					//odczytywanie kolejnych pl z bufora RS-232
	freq1=freq1+(buf[3]-48)*10;
	freq1=freq1+(buf[4]-48)*100;
	freq1=freq1+(buf[5]-48)*1000;
	freq1=freq1+(buf[6]-48)*10000;
	freq1=freq1+(buf[7]-48)*100000;
	freq1=freq1+(buf[8]-48)*1000000;
	freq1=freq1+(buf[9]-48)*10000000;
	freq1=freq1+(buf[10]-48)*100000000;
	
	
	freq2=buf[11]-48;					//odczytywanie kolejnych pl z bufora RS-232
	freq2=freq2+(buf[12]-48)*10;
	freq2=freq2+(buf[13]-48)*100;
	freq2=freq2+(buf[14]-48)*1000;
	freq2=freq2+(buf[15]-48)*10000;
	freq2=freq2+(buf[16]-48)*100000;
	freq2=freq2+(buf[17]-48)*1000000;
	freq2=freq2+(buf[18]-48)*10000000;
	freq2=freq2+(buf[19]-48)*100000000;
	
	gfreq=freq1;
	gfreq2=freq2;
	lcdclr();
	lcdtxt("FM-gniazdo X3");
	lcdxy(0,1);
	sprntf(temp,"%i",freq1);
	lcdtxt("fn=");
	lcdtxt(temp);
	lcdtxt("Hz");
	amplituda(gamp);
	gfreq=gfreq-gfreq2*0.5;
	flaga=2;
	}
	
	if (buf[1]==122)			//litera "z", modulacja QPSK
	{
	freq1=buf[2]-48;					//odczytywanie kolejnych pl z bufora RS-232
	freq1=freq1+(buf[3]-48)*10;
	freq1=freq1+(buf[4]-48)*100;
	freq1=freq1+(buf[5]-48)*1000;
	freq1=freq1+(buf[6]-48)*10000;
	freq1=freq1+(buf[7]-48)*100000;
	freq1=freq1+(buf[8]-48)*1000000;
	freq1=freq1+(buf[9]-48)*10000000;
	freq1=freq1+(buf[10]-48)*100000000;
	
	speed=buf[11]-48;					//odczytywanie kolejnych pl z bufora RS-232
	speed=speed+(buf[12]-48)*10;
	speed=speed+(buf[13]-48)*100;
	speed=speed+(buf[14]-48)*1000;
	speed=speed+(buf[15]-48)*10000;
	
	for (char y=16;y<48;y++)
	gdane[y-16]=buf[y]-48;
	qpsk(freq1,speed);
	}
	
	if (buf[1]==99)			//litera "c", konfiguracja reczna dds'a (czestotliwosc)
	{					//odczytywanie kolejnych pl z bufora RS-232
	a=(buf[2]-48)+10*(buf[3]-48)+100*(buf[4]-48);
	b=(buf[5]-48)+10*(buf[6]-48)+100*(buf[7]-48);
	c=(buf[8]-48)+10*(buf[9]-48)+100*(buf[10]-48);
	d=(buf[11]-48)+10*(buf[12]-48)+100*(buf[13]-48);
	
	wyslij(2);
	wyslij(a);
	wyslij(b);
	wyslij(c);
	wyslij(d);
	wyslij(0);
	wyslij(0);
	setp2;  //IO update
	clrp2;
	}
	
	if (buf[1]==118)			//litera "v", konfiguracja reczna dds'a (amplituda)
	{
								//odczytywanie kolejnych pl z bufora RS-232
	a=(buf[2]-48)+10*(buf[3]-48)+100*(buf[4]-48);
	b=(buf[5]-48)+10*(buf[6]-48)+100*(buf[7]-48);
		
	wyslij(8);
	wyslij(a);
	wyslij(b);
	
	setp2;  //IO update
	clrp2;
	}
	
	if (buf[1]==98)			//litera "b", konfiguracja reczna dds'a (rejestr kontrolny)
	{							//odczytywanie kolejnych pl z bufora RS-232
	a=(buf[2]-48)+10*(buf[3]-48)+100*(buf[4]-48);
	b=(buf[5]-48)+10*(buf[6]-48)+100*(buf[7]-48);
	c=(buf[8]-48)+10*(buf[9]-48)+100*(buf[10]-48);
	d=(buf[11]-48)+10*(buf[12]-48)+100*(buf[13]-48);
	
	wyslij(7);
	wyslij(a);
	wyslij(b);
	wyslij(c);
	wyslij(d);
	setp2;  //IO update
	clrp2;
	}
	x=0;
	data=0;
	for (int y=0;y<129;y++)
	buf[y]=0;
	}
}

void modulacjaam(unsigned long nosna,unsigned int depth,unsigned int speed)
{
AT91PS_PIO p_pPio = AT91C_BASE_PIOA; 
float a=0;
unsigned char x=0;
long c=0;
long d,e;
float temps=0;
unsigned int b=0;
wyslij(7);
wyslij(16);
wyslij(75);
wyslij(1);
wyslij(96);

setp2;  //IO update
clrp2;							
a=depth*0.01;										
a=a*gamp;
c=a*0.5;	
b=gamp-c;
//setfreq(nosna);
for (x=0;x<145;x++)					//przeliczenie prbek przebiegu
{
d=sinus[x%72];
if (x>72)
d=-d;
e=c*d;
e=e>>8;
out[x]=b+e;
}
x=0;
gmode=7;
setfreq(nosna);								//ustawienie nosnej dla modulacji am
delay=2;
speedam=speed*0.001;

if (speed<1932) 
temps=speed*0.10603+1;
else 
temps=speed*0.10607;
speed=(int)temps;


lcdclr();
lcdtxt("AM ");
sprntf(temp,"%i",depth);
lcdtxt(temp);
lcdtxt("% ");
sprntf(temp,"%i",speed);
lcdtxt(temp);
lcdtxt("Hz");
lcdxy(0,1);
lcdtxt("fn=");
sprntf(temp,"%i",nosna);
lcdtxt(temp);
lcdtxt("Hz");



AT91C_BASE_TC1->TC_CCR = AT91C_TC_CLKEN;
AT91C_BASE_TC1->TC_CCR = AT91C_TC_SWTRG ;	//uruchomienie timera 1
}

void modulacjafm(unsigned long nosna,unsigned long dewiacja,unsigned int speed)
{
unsigned char x=0;
long c=0;
for (x=0;x<145;x++)
{
c=sinus[x%72];
if (x>72)
c=-c;
c=c*dewiacja;
c=c>>9;
out[x]=nosna+c;
}
x=0;
gmode=6;
delay=2;
speedfm=speed*0.001;
lcdclr();
lcdtxt("FM d=");
sprntf(temp,"%i",dewiacja);
lcdtxt(temp);
lcdtxt("Hz");
lcdxy(0,1);
lcdtxt("fn=");
sprntf(temp,"%i",nosna);
lcdtxt(temp);
lcdtxt("Hz");



AT91C_BASE_TC1->TC_CCR = AT91C_TC_CLKEN;
AT91C_BASE_TC1->TC_CCR = AT91C_TC_SWTRG ;	
//enablowanie timera z ustalonym delayem

}


int main(void)
{
int wynik=0;
AT91PS_PIO p_pPio = AT91C_BASE_PIOA; 
AT91PS_RSTC p_pRST = AT91C_BASE_RSTC;
AT91F_TC_Open(AT91C_BASE_TC1,1,AT91C_ID_TC1);
//skonfigurowanie przerwania od timera 1
AT91F_AIC_ConfigureIt ( AT91C_BASE_AIC, AT91C_ID_TC1, 7,AT91C_AIC_SRCTYPE_INT_LEVEL_SENSITIVE, timer1_int);
AT91F_AIC_EnableIt (AT91C_BASE_AIC, AT91C_ID_TC1);
setoutport();
setinport();
p_pRST->RSTC_RMR = 0xA5000001; 


a2dInit();
lcdinit();
lcdclr();
lcdxy(0,0);

setp0;					//reset
clrp0;
init_dds();
uart1Init(365, UART_8N1);

lcdtxt("Praca Dyplomowa");
lcdxy(0,1);
lcdtxt("Magisterska");
longdelay();
lcdclr();
lcdtxt("Wykonal: ");
lcdxy(0,1);
lcdtxt("Rafal Stepien");
longdelay();
lcdclr();
lcdtxt("Promotor dr inz.");
lcdxy(0,1);
lcdtxt("Piotr Swiszcz");
longdelay();
lcdclr();
lcdtxt("Gotowy");
gamp=4095;
amplituda(gamp);

float mnoznik=0;
setp13;						//stany niskie na obu pinach synchronizacyjnych
clrp14;

while(1)
{

//AM, FM, PM sprztowe w oparciu o prbkowanie przebiegu analogowego z gniazda X3
		
	if (flaga==1) 
	{
	wynik=a2dConvert(4);
	wynik=4*wynik;
	amplituda(wynik);
	_delay(1);
	}

	if (flaga==2) 
	{
	wynik=a2dConvert(4);
	dev=(gfreq2*wynik)>>10;
	setfreq(gfreq+dev);
	_delay(1);
	}
	
	
	if (flaga==3) 
	{
	wynik=a2dConvert(4);
	mnoznik=wynik*0.362;
	wynik=(int)mnoznik;
	setphs(wynik);
	_delay(2);
	}


}

return 0;
}
